// -*- C++ -*-
/*!
 * @file  CeilingNavigation.h
 * @brief CeilingNavigation
 * @date  $Date$
 *
 * $Id$
 */

#ifndef CEILINGNAVIGATION_H
#define CEILINGNAVIGATION_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

#include "std_hdr.h"

#include "intellirobotStub.h"

#include "BlockMatching.h"
#include "ImageData.h"
#include "CeilingMap.h"

using namespace RTC;

/**
 *@brief VirQ[VRTCCNX
 */
class CeilingNavigation
  : public RTC::DataFlowComponentBase
{
 public:
  CeilingNavigation(RTC::Manager* manager);
  ~CeilingNavigation();
 
  virtual RTC::ReturnCode_t onInitialize();
  virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);
  virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);
  virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

 protected:
	std::string m_NavigationMap;		/* V摜t@C						*/
	unsigned short m_BlockResolution;	/* 摜]\							*/
	unsigned short m_BlockSize;			/* 摜kTCY							*/
	double m_BlockCoefficient;			/* 摜k␳l							*/
	unsigned short m_SearchScope;		/* }b`OT͈						*/
	unsigned short m_BlackWhiteValue;	/* 2l臒l								*/
	long m_Center_X;					/* 摜]SW(X)						*/
	long m_Center_Y;					/* 摜]SW(Y)						*/
	std::string m_OfflineImage;			/* ItCC[Wt@Ci[tH_ */
	double m_RealMapHeight;
	double m_RealMapWidth;
	double m_VirtualMapHeight;
	double m_VirtualMapWidth;

	unsigned long x_pos;
	unsigned long y_pos;
	double theta;

	double mPerPix;//摜1sNZ̎E̒[m]
	//{bgWńCOx,yƂD
	double camX; //{bgWnɂJxW
	double camY; //{bgWnɂJyW
	//pxɂẮC摜̏{bgWxɈv悤ɔzuƂƂŌŒ肷D

  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  TimedOctetSeq m_CameraData;
  InPort<TimedOctetSeq> m_CameraDataIn;
 
	IIS::TimedPose2D m_LocalizedPosition;
	InPort<IIS::TimedPose2D> m_LocalizedPositionIn; 

  IIS::TimedPose2D m_CeilingPosition;
  OutPort<IIS::TimedPose2D> m_CeilingPositionOut;
  
 private:
  int dummy;
  private:
	  BlockMatching	m_BlockMat;
	  CeilingMap	m_CeilingMap;

};


extern "C"
{
  void CeilingNavigationInit(RTC::Manager* manager);
};

#endif // CEILINGNAVIGATION_H
